"""
Generated by Erda Migrator.
Please implement the function entry, and add it to the list entries.
"""

import django.db.models


class DiceRelease(django.db.models.Model):
    """
    generated by erda-cli
    """

    release_id = django.db.models.CharField(primary_key=True)
    release_name = django.db.models.CharField()
    desc = django.db.models.TextField()
    dice = django.db.models.TextField()
    addon = django.db.models.TextField()
    labels = django.db.models.CharField()
    version = django.db.models.CharField()
    org_id = django.db.models.BigIntegerField()
    project_id = django.db.models.BigIntegerField()
    application_id = django.db.models.BigIntegerField()
    project_name = django.db.models.CharField()
    application_name = django.db.models.CharField()
    user_id = django.db.models.CharField()
    cluster_name = django.db.models.CharField()
    cross_cluster = django.db.models.BooleanField()
    resources = django.db.models.TextField()
    reference = django.db.models.BigIntegerField()
    created_at = django.db.models.DateTimeField()
    updated_at = django.db.models.DateTimeField()
    changelog = django.db.models.TextField()
    is_stable = django.db.models.BooleanField()
    is_formal = django.db.models.BooleanField()
    is_project_release = django.db.models.BooleanField()
    application_release_list = django.db.models.TextField()
    tags = django.db.models.CharField()
    git_branch = django.db.models.CharField()
    is_latest = django.db.models.BooleanField()

    class Meta:
        db_table = "dice_release"


def entry():
    releases = DiceRelease.objects.all()

    d = dict()

    for release in releases:
        if release.is_project_release or (not release.is_stable):
            continue
        h = '{},{},{}'.format(release.project_id, release.application_id, release.git_branch)
        if (not h in d) or d[h].created_at < release.created_at:
            d[h] = release

    for rel in d.values():
        rel.is_latest = True
        rel.save()

entries: [callable] = [
    entry,
]
