// Code generated by protoc-gen-go-client. DO NOT EDIT.
// Sources: openapi_consumer.proto

package client

import (
	fmt "fmt"
	reflect "reflect"
	strings "strings"

	servicehub "github.com/erda-project/erda-infra/base/servicehub"
	grpc "github.com/erda-project/erda-infra/pkg/transport/grpc"
	pb "github.com/erda-project/erda-proto-go/core/hepa/openapi_consumer/pb"
	grpc1 "google.golang.org/grpc"
)

var dependencies = []string{
	"grpc-client@erda.core.hepa.openapi_consumer",
	"grpc-client",
}

// +provider
type provider struct {
	client Client
}

func (p *provider) Init(ctx servicehub.Context) error {
	var conn grpc.ClientConnInterface
	for _, dep := range dependencies {
		c, ok := ctx.Service(dep).(grpc.ClientConnInterface)
		if ok {
			conn = c
			break
		}
	}
	if conn == nil {
		return fmt.Errorf("not found connector in (%s)", strings.Join(dependencies, ", "))
	}
	p.client = New(conn)
	return nil
}

var (
	clientsType                      = reflect.TypeOf((*Client)(nil)).Elem()
	openapiConsumerServiceClientType = reflect.TypeOf((*pb.OpenapiConsumerServiceClient)(nil)).Elem()
	openapiConsumerServiceServerType = reflect.TypeOf((*pb.OpenapiConsumerServiceServer)(nil)).Elem()
)

func (p *provider) Provide(ctx servicehub.DependencyContext, args ...interface{}) interface{} {
	var opts []grpc1.CallOption
	for _, arg := range args {
		if opt, ok := arg.(grpc1.CallOption); ok {
			opts = append(opts, opt)
		}
	}
	switch ctx.Service() {
	case "erda.core.hepa.openapi_consumer-client":
		return p.client
	case "erda.core.hepa.openapi_consumer.OpenapiConsumerService":
		return &openapiConsumerServiceWrapper{client: p.client.OpenapiConsumerService(), opts: opts}
	case "erda.core.hepa.openapi_consumer.OpenapiConsumerService.client":
		return p.client.OpenapiConsumerService()
	}
	switch ctx.Type() {
	case clientsType:
		return p.client
	case openapiConsumerServiceClientType:
		return p.client.OpenapiConsumerService()
	case openapiConsumerServiceServerType:
		return &openapiConsumerServiceWrapper{client: p.client.OpenapiConsumerService(), opts: opts}
	}
	return p
}

func init() {
	servicehub.Register("erda.core.hepa.openapi_consumer-client", &servicehub.Spec{
		Services: []string{
			"erda.core.hepa.openapi_consumer.OpenapiConsumerService",
			"erda.core.hepa.openapi_consumer.OpenapiConsumerService.client",
			"erda.core.hepa.openapi_consumer-client",
		},
		Types: []reflect.Type{
			clientsType,
			// client types
			openapiConsumerServiceClientType,
			// server types
			openapiConsumerServiceServerType,
		},
		OptionalDependencies: dependencies,
		Creator: func() servicehub.Provider {
			return &provider{}
		},
	})
}
