// Code generated by protoc-gen-go-http. DO NOT EDIT.
// Source: expression.proto

package pb

import (
	context "context"
	http1 "net/http"

	transport "github.com/erda-project/erda-infra/pkg/transport"
	http "github.com/erda-project/erda-infra/pkg/transport/http"
	urlenc "github.com/erda-project/erda-infra/pkg/urlenc"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the "github.com/erda-project/erda-infra/pkg/transport/http" package it is being compiled against.
const _ = http.SupportPackageIsVersion1

// ExpressionServiceHandler is the server API for ExpressionService service.
type ExpressionServiceHandler interface {
	// GET /api/alert/expressions
	GetAlertExpressions(context.Context, *GetExpressionsRequest) (*GetExpressionsResponse, error)
	// GET /api/metric/expressions
	GetMetricExpressions(context.Context, *GetMetricExpressionsRequest) (*GetMetricExpressionsResponse, error)
	// GET /api/alert/notifies
	GetAlertNotifies(context.Context, *GetAlertNotifiesRequest) (*GetAlertNotifiesResponse, error)
	// GET /api/alert/templates
	GetTemplates(context.Context, *GetTemplatesRequest) (*GetTemplatesResponse, error)
}

// RegisterExpressionServiceHandler register ExpressionServiceHandler to http.Router.
func RegisterExpressionServiceHandler(r http.Router, srv ExpressionServiceHandler, opts ...http.HandleOption) {
	h := http.DefaultHandleOptions()
	for _, op := range opts {
		op(h)
	}
	encodeFunc := func(fn func(http1.ResponseWriter, *http1.Request) (interface{}, error)) http.HandlerFunc {
		handler := func(w http1.ResponseWriter, r *http1.Request) {
			out, err := fn(w, r)
			if err != nil {
				h.Error(w, r, err)
				return
			}
			if err := h.Encode(w, r, out); err != nil {
				h.Error(w, r, err)
			}
		}
		if h.HTTPInterceptor != nil {
			handler = h.HTTPInterceptor(handler)
		}
		return handler
	}

	add_GetAlertExpressions := func(method, path string, fn func(context.Context, *GetExpressionsRequest) (*GetExpressionsResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetExpressionsRequest))
		}
		var GetAlertExpressions_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetAlertExpressions_info = transport.NewServiceInfo("erda.core.monitor.expression.ExpressionService", "GetAlertExpressions", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetAlertExpressions_info)
				}
				r = r.WithContext(ctx)
				var in GetExpressionsRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetMetricExpressions := func(method, path string, fn func(context.Context, *GetMetricExpressionsRequest) (*GetMetricExpressionsResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetMetricExpressionsRequest))
		}
		var GetMetricExpressions_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetMetricExpressions_info = transport.NewServiceInfo("erda.core.monitor.expression.ExpressionService", "GetMetricExpressions", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetMetricExpressions_info)
				}
				r = r.WithContext(ctx)
				var in GetMetricExpressionsRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetAlertNotifies := func(method, path string, fn func(context.Context, *GetAlertNotifiesRequest) (*GetAlertNotifiesResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetAlertNotifiesRequest))
		}
		var GetAlertNotifies_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetAlertNotifies_info = transport.NewServiceInfo("erda.core.monitor.expression.ExpressionService", "GetAlertNotifies", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetAlertNotifies_info)
				}
				r = r.WithContext(ctx)
				var in GetAlertNotifiesRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetTemplates := func(method, path string, fn func(context.Context, *GetTemplatesRequest) (*GetTemplatesResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetTemplatesRequest))
		}
		var GetTemplates_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetTemplates_info = transport.NewServiceInfo("erda.core.monitor.expression.ExpressionService", "GetTemplates", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetTemplates_info)
				}
				r = r.WithContext(ctx)
				var in GetTemplatesRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetAlertExpressions("GET", "/api/alert/expressions", srv.GetAlertExpressions)
	add_GetMetricExpressions("GET", "/api/metric/expressions", srv.GetMetricExpressions)
	add_GetAlertNotifies("GET", "/api/alert/notifies", srv.GetAlertNotifies)
	add_GetTemplates("GET", "/api/alert/templates", srv.GetTemplates)
}
