// Code generated by protoc-gen-go-client. DO NOT EDIT.
// Sources: source.proto

package client

import (
	fmt "fmt"
	reflect "reflect"
	strings "strings"

	servicehub "github.com/erda-project/erda-infra/base/servicehub"
	grpc "github.com/erda-project/erda-infra/pkg/transport/grpc"
	pb "github.com/erda-project/erda-proto-go/core/pipeline/source/pb"
	grpc1 "google.golang.org/grpc"
)

var dependencies = []string{
	"grpc-client@erda.core.pipeline.source",
	"grpc-client",
}

// +provider
type provider struct {
	client Client
}

func (p *provider) Init(ctx servicehub.Context) error {
	var conn grpc.ClientConnInterface
	for _, dep := range dependencies {
		c, ok := ctx.Service(dep).(grpc.ClientConnInterface)
		if ok {
			conn = c
			break
		}
	}
	if conn == nil {
		return fmt.Errorf("not found connector in (%s)", strings.Join(dependencies, ", "))
	}
	p.client = New(conn)
	return nil
}

var (
	clientsType             = reflect.TypeOf((*Client)(nil)).Elem()
	sourceServiceClientType = reflect.TypeOf((*pb.SourceServiceClient)(nil)).Elem()
	sourceServiceServerType = reflect.TypeOf((*pb.SourceServiceServer)(nil)).Elem()
)

func (p *provider) Provide(ctx servicehub.DependencyContext, args ...interface{}) interface{} {
	var opts []grpc1.CallOption
	for _, arg := range args {
		if opt, ok := arg.(grpc1.CallOption); ok {
			opts = append(opts, opt)
		}
	}
	switch ctx.Service() {
	case "erda.core.pipeline.source-client":
		return p.client
	case "erda.core.pipeline.source.SourceService":
		return &sourceServiceWrapper{client: p.client.SourceService(), opts: opts}
	case "erda.core.pipeline.source.SourceService.client":
		return p.client.SourceService()
	}
	switch ctx.Type() {
	case clientsType:
		return p.client
	case sourceServiceClientType:
		return p.client.SourceService()
	case sourceServiceServerType:
		return &sourceServiceWrapper{client: p.client.SourceService(), opts: opts}
	}
	return p
}

func init() {
	servicehub.Register("erda.core.pipeline.source-client", &servicehub.Spec{
		Services: []string{
			"erda.core.pipeline.source.SourceService",
			"erda.core.pipeline.source.SourceService.client",
			"erda.core.pipeline.source-client",
		},
		Types: []reflect.Type{
			clientsType,
			// client types
			sourceServiceClientType,
			// server types
			sourceServiceServerType,
		},
		OptionalDependencies: dependencies,
		Creator: func() servicehub.Provider {
			return &provider{}
		},
	})
}
