// Code generated by protoc-gen-go-client. DO NOT EDIT.
// Sources: service.proto

package client

import (
	fmt "fmt"
	reflect "reflect"
	strings "strings"

	servicehub "github.com/erda-project/erda-infra/base/servicehub"
	grpc "github.com/erda-project/erda-infra/pkg/transport/grpc"
	pb "github.com/erda-project/erda-proto-go/msp/apm/service/pb"
	grpc1 "google.golang.org/grpc"
)

var dependencies = []string{
	"grpc-client@erda.msp.apm.service",
	"grpc-client",
}

// +provider
type provider struct {
	client Client
}

func (p *provider) Init(ctx servicehub.Context) error {
	var conn grpc.ClientConnInterface
	for _, dep := range dependencies {
		c, ok := ctx.Service(dep).(grpc.ClientConnInterface)
		if ok {
			conn = c
			break
		}
	}
	if conn == nil {
		return fmt.Errorf("not found connector in (%s)", strings.Join(dependencies, ", "))
	}
	p.client = New(conn)
	return nil
}

var (
	clientsType                 = reflect.TypeOf((*Client)(nil)).Elem()
	apmServiceServiceClientType = reflect.TypeOf((*pb.ApmServiceServiceClient)(nil)).Elem()
	apmServiceServiceServerType = reflect.TypeOf((*pb.ApmServiceServiceServer)(nil)).Elem()
)

func (p *provider) Provide(ctx servicehub.DependencyContext, args ...interface{}) interface{} {
	var opts []grpc1.CallOption
	for _, arg := range args {
		if opt, ok := arg.(grpc1.CallOption); ok {
			opts = append(opts, opt)
		}
	}
	switch ctx.Service() {
	case "erda.msp.apm.service-client":
		return p.client
	case "erda.msp.apm.service.ApmServiceService":
		return &apmServiceServiceWrapper{client: p.client.ApmServiceService(), opts: opts}
	case "erda.msp.apm.service.ApmServiceService.client":
		return p.client.ApmServiceService()
	}
	switch ctx.Type() {
	case clientsType:
		return p.client
	case apmServiceServiceClientType:
		return p.client.ApmServiceService()
	case apmServiceServiceServerType:
		return &apmServiceServiceWrapper{client: p.client.ApmServiceService(), opts: opts}
	}
	return p
}

func init() {
	servicehub.Register("erda.msp.apm.service-client", &servicehub.Spec{
		Services: []string{
			"erda.msp.apm.service.ApmServiceService",
			"erda.msp.apm.service.ApmServiceService.client",
			"erda.msp.apm.service-client",
		},
		Types: []reflect.Type{
			clientsType,
			// client types
			apmServiceServiceClientType,
			// server types
			apmServiceServiceServerType,
		},
		OptionalDependencies: dependencies,
		Creator: func() servicehub.Provider {
			return &provider{}
		},
	})
}
