// Code generated by protoc-gen-go-http. DO NOT EDIT.
// Source: service.proto

package pb

import (
	context "context"
	http1 "net/http"

	transport "github.com/erda-project/erda-infra/pkg/transport"
	http "github.com/erda-project/erda-infra/pkg/transport/http"
	urlenc "github.com/erda-project/erda-infra/pkg/urlenc"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the "github.com/erda-project/erda-infra/pkg/transport/http" package it is being compiled against.
const _ = http.SupportPackageIsVersion1

// ApmServiceServiceHandler is the server API for ApmServiceService service.
type ApmServiceServiceHandler interface {
	// GET /api/msp/apm/services
	GetServices(context.Context, *GetServicesRequest) (*GetServicesResponse, error)
	// GET /api/msp/apm/service/analyzer-overview
	GetServiceAnalyzerOverview(context.Context, *GetServiceAnalyzerOverviewRequest) (*GetServiceAnalyzerOverviewResponse, error)
	// GET /api/msp/apm/service/count
	GetServiceCount(context.Context, *GetServiceCountRequest) (*GetServiceCountResponse, error)
	// GET /api/msp/apm/service/language
	GetServiceLanguage(context.Context, *GetServiceLanguageRequest) (*GetServiceLanguageResponse, error)
}

// RegisterApmServiceServiceHandler register ApmServiceServiceHandler to http.Router.
func RegisterApmServiceServiceHandler(r http.Router, srv ApmServiceServiceHandler, opts ...http.HandleOption) {
	h := http.DefaultHandleOptions()
	for _, op := range opts {
		op(h)
	}
	encodeFunc := func(fn func(http1.ResponseWriter, *http1.Request) (interface{}, error)) http.HandlerFunc {
		handler := func(w http1.ResponseWriter, r *http1.Request) {
			out, err := fn(w, r)
			if err != nil {
				h.Error(w, r, err)
				return
			}
			if err := h.Encode(w, r, out); err != nil {
				h.Error(w, r, err)
			}
		}
		if h.HTTPInterceptor != nil {
			handler = h.HTTPInterceptor(handler)
		}
		return handler
	}

	add_GetServices := func(method, path string, fn func(context.Context, *GetServicesRequest) (*GetServicesResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetServicesRequest))
		}
		var GetServices_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetServices_info = transport.NewServiceInfo("erda.msp.apm.service.ApmServiceService", "GetServices", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetServices_info)
				}
				r = r.WithContext(ctx)
				var in GetServicesRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetServiceAnalyzerOverview := func(method, path string, fn func(context.Context, *GetServiceAnalyzerOverviewRequest) (*GetServiceAnalyzerOverviewResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetServiceAnalyzerOverviewRequest))
		}
		var GetServiceAnalyzerOverview_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetServiceAnalyzerOverview_info = transport.NewServiceInfo("erda.msp.apm.service.ApmServiceService", "GetServiceAnalyzerOverview", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetServiceAnalyzerOverview_info)
				}
				r = r.WithContext(ctx)
				var in GetServiceAnalyzerOverviewRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetServiceCount := func(method, path string, fn func(context.Context, *GetServiceCountRequest) (*GetServiceCountResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetServiceCountRequest))
		}
		var GetServiceCount_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetServiceCount_info = transport.NewServiceInfo("erda.msp.apm.service.ApmServiceService", "GetServiceCount", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetServiceCount_info)
				}
				r = r.WithContext(ctx)
				var in GetServiceCountRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetServiceLanguage := func(method, path string, fn func(context.Context, *GetServiceLanguageRequest) (*GetServiceLanguageResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetServiceLanguageRequest))
		}
		var GetServiceLanguage_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetServiceLanguage_info = transport.NewServiceInfo("erda.msp.apm.service.ApmServiceService", "GetServiceLanguage", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetServiceLanguage_info)
				}
				r = r.WithContext(ctx)
				var in GetServiceLanguageRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetServices("GET", "/api/msp/apm/services", srv.GetServices)
	add_GetServiceAnalyzerOverview("GET", "/api/msp/apm/service/analyzer-overview", srv.GetServiceAnalyzerOverview)
	add_GetServiceCount("GET", "/api/msp/apm/service/count", srv.GetServiceCount)
	add_GetServiceLanguage("GET", "/api/msp/apm/service/language", srv.GetServiceLanguage)
}
