// Code generated by protoc-gen-go-http. DO NOT EDIT.
// Source: tenant.proto

package pb

import (
	context "context"
	http1 "net/http"

	transport "github.com/erda-project/erda-infra/pkg/transport"
	http "github.com/erda-project/erda-infra/pkg/transport/http"
	urlenc "github.com/erda-project/erda-infra/pkg/urlenc"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the "github.com/erda-project/erda-infra/pkg/transport/http" package it is being compiled against.
const _ = http.SupportPackageIsVersion1

// TenantServiceHandler is the server API for TenantService service.
type TenantServiceHandler interface {
	// POST /api/msp/tenant
	CreateTenant(context.Context, *CreateTenantRequest) (*CreateTenantResponse, error)
	// GET /api/msp/tenant
	GetTenant(context.Context, *GetTenantRequest) (*GetTenantResponse, error)
	// DELETE /api/msp/tenant
	DeleteTenant(context.Context, *DeleteTenantRequest) (*DeleteTenantResponse, error)
	// GET /api/msp/tenant/projectInfo
	GetTenantProject(context.Context, *GetTenantProjectRequest) (*GetTenantProjectResponse, error)
}

// RegisterTenantServiceHandler register TenantServiceHandler to http.Router.
func RegisterTenantServiceHandler(r http.Router, srv TenantServiceHandler, opts ...http.HandleOption) {
	h := http.DefaultHandleOptions()
	for _, op := range opts {
		op(h)
	}
	encodeFunc := func(fn func(http1.ResponseWriter, *http1.Request) (interface{}, error)) http.HandlerFunc {
		handler := func(w http1.ResponseWriter, r *http1.Request) {
			out, err := fn(w, r)
			if err != nil {
				h.Error(w, r, err)
				return
			}
			if err := h.Encode(w, r, out); err != nil {
				h.Error(w, r, err)
			}
		}
		if h.HTTPInterceptor != nil {
			handler = h.HTTPInterceptor(handler)
		}
		return handler
	}

	add_CreateTenant := func(method, path string, fn func(context.Context, *CreateTenantRequest) (*CreateTenantResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*CreateTenantRequest))
		}
		var CreateTenant_info transport.ServiceInfo
		if h.Interceptor != nil {
			CreateTenant_info = transport.NewServiceInfo("erda.msp.tenant.TenantService", "CreateTenant", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, CreateTenant_info)
				}
				r = r.WithContext(ctx)
				var in CreateTenantRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				params := r.URL.Query()
				if vals := params["projectId"]; len(vals) > 0 {
					in.ProjectID = vals[0]
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetTenant := func(method, path string, fn func(context.Context, *GetTenantRequest) (*GetTenantResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetTenantRequest))
		}
		var GetTenant_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetTenant_info = transport.NewServiceInfo("erda.msp.tenant.TenantService", "GetTenant", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetTenant_info)
				}
				r = r.WithContext(ctx)
				var in GetTenantRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				params := r.URL.Query()
				if vals := params["projectId"]; len(vals) > 0 {
					in.ProjectID = vals[0]
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_DeleteTenant := func(method, path string, fn func(context.Context, *DeleteTenantRequest) (*DeleteTenantResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*DeleteTenantRequest))
		}
		var DeleteTenant_info transport.ServiceInfo
		if h.Interceptor != nil {
			DeleteTenant_info = transport.NewServiceInfo("erda.msp.tenant.TenantService", "DeleteTenant", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, DeleteTenant_info)
				}
				r = r.WithContext(ctx)
				var in DeleteTenantRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				params := r.URL.Query()
				if vals := params["projectId"]; len(vals) > 0 {
					in.ProjectID = vals[0]
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetTenantProject := func(method, path string, fn func(context.Context, *GetTenantProjectRequest) (*GetTenantProjectResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetTenantProjectRequest))
		}
		var GetTenantProject_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetTenantProject_info = transport.NewServiceInfo("erda.msp.tenant.TenantService", "GetTenantProject", srv)
			handler = h.Interceptor(handler)
		}
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetTenantProject_info)
				}
				r = r.WithContext(ctx)
				var in GetTenantProjectRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_CreateTenant("POST", "/api/msp/tenant", srv.CreateTenant)
	add_GetTenant("GET", "/api/msp/tenant", srv.GetTenant)
	add_DeleteTenant("DELETE", "/api/msp/tenant", srv.DeleteTenant)
	add_GetTenantProject("GET", "/api/msp/tenant/projectInfo", srv.GetTenantProject)
}
