// Copyright (c) 2021 Terminus, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package autotest

import (
	"net/http"

	"github.com/erda-project/erda/apistructs"
	"github.com/erda-project/erda/modules/openapi/api/apis"
)

var GLOBAL_CONFIG_UPDATE = apis.ApiSpec{
	Path:         "/api/autotests/global-configs/<ns>",
	BackendPath:  "/api/autotests/global-configs/<ns>",
	Host:         "dop.marathon.l4lb.thisdcos.directory:9527",
	Scheme:       "http",
	Method:       http.MethodPut,
	CheckLogin:   true,
	RequestType:  apistructs.AutoTestGlobalConfigUpdateRequest{},
	ResponseType: apistructs.AutoTestGlobalConfigUpdateResponse{},
	Doc:          "更新自动化测试全局配置",
}
