// Copyright (c) 2021 Terminus, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package i18n

var (
	I18nKeyPlan                          = "autotest.plan.plan"
	I18nKeyNewPlan                       = "autotest.plan.new.plan"
	I18nKeyPlanName                      = "autotest.plan.plan.name"
	I18nKeyPlanNameRegex                 = "autotest.plan.plan.regex"
	I18nKeyPlanStep                      = "autotest.plan.step"
	I18nKeyPlanDetail                    = "autotest.plan.detail"
	I18nKeyPlanNull                      = "autotest.plan.null"
	I18nKeyTestSpace                     = "autotest.plan.test.space"
	I18nKeyTaskParameter                 = "autotest.plan.task.parameter"
	I18nKeyParameterConfiguration        = "autotest.plan.parameter.configuration"
	I18nKeySceneSet                      = "autotest.plan.autotest.scene.set"
	I18nKeyScene                         = "autotest.plan.autotest.scene"
	I18nKeyIteration                     = "autotest.plan.iteration"
	I18nKeyPrincipal                     = "autotest.plan.principal"
	I18nKeyArchive                       = "autotest.plan.archive"
	I18nKeyUnarchive                     = "autotest.plan.un.archive"
	I18nKeyInProgress                    = "autotest.plan.in.progress"
	I18nKeyArchived                      = "autotest.plan.archived"
	I18nKeyAll                           = "autotest.plan.all"
	I18nKeyPlanID                        = "autotest.plan.id"
	I18nKeyTotalInterfaces               = "autotest.plan.total.executed.interfaces"
	I18nKeyPassRate                      = "autotest.plan.execution.pass.rate"
	I18nKeyExecutionTime                 = "autotest.plan.execution.time"
	I18nKeyOperations                    = "autotest.plan.operations"
	I18nKeyEdit                          = "autotest.plan.edit"
	I18nKeyExecute                       = "autotest.plan.execute"
	I18nKeyConfigurationInformation      = "autotest.plan.configuration.information"
	I18nKeyUnExecute                     = "autotest.plan.un.execute"
	I18nKeyWhetherCancel                 = "autotest.plan.whether.confirm.cancel"
	I18nKeyEnvironDomain                 = "autotest.plan.environ.domain"
	I18nKeyBaseInfo                      = "autotest.plan.base.information"
	I18nKeyTable                         = "autotest.plan.table"
	I18nKeyText                          = "autotest.plan.text"
	I18nKeyName                          = "autotest.plan.name"
	I18nKeyParameterType                 = "autotest.plan.parameter.type"
	I18nKeyParameterContent              = "autotest.plan.parameter.content"
	I18nKeyDescription                   = "autotest.plan.description"
	I18nKeyHistoryExecute                = "autotest.plan.execute.history"
	I18nKeyBackLatestRecord              = "autotest.plan.back.latest.record"
	I18nKeyVersion                       = "autotest.plan.version"
	I18nKeyStatus                        = "autotest.plan.status"
	I18nKeyExecutor                      = "autotest.plan.executor"
	I18nKeyTriggerTime                   = "autotest.plan.trigger.time"
	I18nKeyUserCancels                   = "autotest.plan.user.cancel"
	I18nKeyNoNeedExecute                 = "autotest.plan.no.need.execute"
	I18nKeyPipelineID                    = "autotest.plan.pipeline.id"
	I18nKeyDuration                      = "autotest.plan.duration"
	I18nKeyStartTime                     = "autotest.plan.start.time"
	I18nKeyEndTime                       = "autotest.plan.end.time"
	I18nKeyTotalInterface                = "autotest.plan.total.interfaces"
	I18nKeyTotalInterfaceTip             = "autotest.plan.total.interfaces.tips"
	I18nKeyTotalInterfaceExecutionRate   = "autotest.plan.total.interface.execution.rate"
	I18nKeyTotalInterfacePassRate        = "autotest.plan.total.interface.pass.rate"
	I18nKeyTotalInterfaceExecutionParams = "autotest.plan.total.interface.execution.params"
	I18nKeyTotalImplementationDetail     = "autotest.plan.total.implementation.detail"
	I18nKeyStepName                      = "autotest.plan.step.name"
	I18nKeyStepType                      = "autotest.plan.step.type"
	I18nKeyStep                          = "autotest.plan.step.step"
	I18nKeyNumberOfSubtasks              = "autotest.plan.subtask.number"
	I18nKeyStepExecutionTime             = "autotest.plan.step.execution.time"
	I18nKeyInterfacePath                 = "autotest.plan.interface.path"
	I18nKeyWait                          = "autotest.plan.wait"
	I18nKeyInterface                     = "autotest.plan.interface"
	I18nKeyConfigSheet                   = "autotest.plan.config.sheet"
	I18nKeyCustomize                     = "autotest.plan.custom"
	I18nKeyViewResult                    = "autotest.plan.view.result"
	I18nKeyDisableTaskTip                = "autotest.plan.disable.task.tip"
	I18nKeyLog                           = "autotest.plan.log"
	I18nKeyDisableLogTip                 = "autotest.plan.disable.log.tip"
	I18nKeyExecutionDetail               = "autotest.plan.execution.detail"
	I18nKeyCreator                       = "autotest.plan.creator"
	I18nKeyCreationTime                  = "autotest.plan.creation.time"
	I18nKeyUpdater                       = "autotest.plan.updater"
	I18nKeyUpdateTime                    = "autotest.plan.update.time"
	I18nKeyRefresh                       = "autotest.plan.refresh"
	I18nKeyChoose                        = "autotest.plan.choose"
	I18nKeySelectSceneSet                = "autotest.plan.select.scene.set"
	I18nKeyAddStep                       = "autotest.plan.add.step"
	I18nKeyChangeSerial                  = "autotest.plan.change.serial"
	I18nKeyStatusInitialized             = "autotest.plan.status.initialized"
	I18nKeyStatusCreated                 = "autotest.plan.status.created"
	I18nKeyStatusQueue                   = "autotest.plan.status.queue"
	I18nKeyStatusExecuting               = "autotest.plan.status.executing"
	I18nKeyStatusExecuteSuccess          = "autotest.plan.status.execute.success"
	I18nKeyStatusExecuteFailed           = "autotest.plan.status.execute.failed"
	I18nKeyStatusInitializeFailed        = "autotest.plan.status.initialize.failed"
	I18nKeyStatusPause                   = "autotest.plan.status.pause"
	I18nKeyStatusCreateFailed            = "autotest.plan.status.create.failed"
	I18nKeyStatusStartFailed             = "autotest.plan.status.start.failed"
	I18nKeyStatusTimeout                 = "autotest.plan.status.timeout"
	I18nKeyStatusCanceled                = "autotest.plan.status.canceled"
	I18nKeyStatusInitializing            = "autotest.plan.status.initializing"
	I18nKeyStatusAbnormal                = "autotest.plan.status.abnormal"
	I18nKeyStatusDisable                 = "autotest.plan.status.disable"
	I18nKeyStatusApprovalWait            = "autotest.plan.status.wait.approval"
	I18nKeyStatusApprovalSuccess         = "autotest.plan.status.approval.success"
	I18nKeyStatusApprovalFailed          = "autotest.plan.status.approval.failed"
)
