UPDATE `sp_alert_rules` SET `enable` = 0;
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("addon_elasticsearch_cpu","org","addon","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","ElasticSearch实例CPU使用率异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"in\",\"tag\":\"addon_type\",\"value\":[\"terminus-elasticsearch\",\"elasticsearch-operator\"]}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"cpu_usage_percent\",\"field_script\":\"function invoke(fields,tags){return fields.cpu_limit===0?fields.cpu_usage_percent:fields.cpu_usage_percent/fields.cpu_limit}\",\"operator\":\"gte\",\"value\":90},{\"aggregator\":\"max\",\"alias\":\"cpu_limit_value\",\"field\":\"cpu_limit\"},{\"aggregator\":\"max\",\"alias\":\"cpu_allocation_value\",\"field\":\"cpu_allocation\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("addon_elasticsearch_mem","org","addon","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","Elasticsearch实例内存使用率异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"in\",\"tag\":\"addon_type\",\"value\":[\"terminus-elasticsearch\",\"elasticsearch-operator\"]}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"mem_usage_percent\",\"operator\":\"gte\",\"value\":90},{\"aggregator\":\"max\",\"alias\":\"mem_limit_value\",\"field\":\"mem_limit\"},{\"aggregator\":\"max\",\"alias\":\"mem_allocation_value\",\"field\":\"mem_allocation\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("addon_mysql_cpu","org","addon","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","MySQL实例CPU使用率异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"in\",\"tag\":\"addon_type\",\"value\":[\"mysql\"]}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"cpu_usage_percent\",\"field_script\":\"function invoke(fields,tags){return fields.cpu_limit===0?fields.cpu_usage_percent:fields.cpu_usage_percent/fields.cpu_limit}\",\"operator\":\"gte\",\"value\":90},{\"aggregator\":\"max\",\"alias\":\"cpu_limit_value\",\"field\":\"cpu_limit\"},{\"aggregator\":\"max\",\"alias\":\"cpu_allocation_value\",\"field\":\"cpu_allocation\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("addon_mysql_mem","org","addon","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","MySQL实例内存使用率异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"in\",\"tag\":\"addon_type\",\"value\":[\"mysql\"]}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"mem_usage_percent\",\"operator\":\"gte\",\"value\":85},{\"aggregator\":\"max\",\"alias\":\"mem_limit_value\",\"field\":\"mem_limit\"},{\"aggregator\":\"max\",\"alias\":\"mem_allocation_value\",\"field\":\"mem_allocation\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("addon_mysql_slave_status","org","addon","{\"alert_group\":\"{{cluster_name}}-{{addon_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{addon_id}}\"}","MySQL实例主从同步异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"is_slave\",\"value\":\"true\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"slave_slave_running_ok_value\",\"field\":\"slave_slave_running_ok\",\"field_script\":\"function invoke(fields,tags){return (fields.slave_slave_io_running==0 || fields.slave_slave_sql_running==0)?0:1}\",\"operator\":\"neq\",\"value\":1},{\"aggregator\":\"max\",\"alias\":\"slave_slave_sql_running_value\",\"field\":\"slave_slave_sql_running\"},{\"aggregator\":\"max\",\"alias\":\"slave_slave_io_running_value\",\"field\":\"slave_slave_io_running\"}],\"group\":[\"addon_id\",\"server\"],\"metric\":\"mysql\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("addon_redis_mem","org","addon","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","redis实例内存使用率异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"in\",\"tag\":\"addon_type\",\"value\":[\"redis\"]}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"mem_usage_percent\",\"operator\":\"gte\",\"value\":85},{\"aggregator\":\"max\",\"alias\":\"mem_limit_value\",\"field\":\"mem_limit\"},{\"aggregator\":\"max\",\"alias\":\"mem_allocation_value\",\"field\":\"mem_allocation\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_browser_ajax_req","micro_service","app_browser","{\"alert_group\":\"{{tk}}-{{req_path}}-{{host}}\",\"display_url_id\":\"micro_bi_ajax\",\"level\":\"WARNING\",\"recover\":\"false\"}","Ajax接口访问性能","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"tk\",\"value\":\"$tk\"},{\"operator\":\"eq\",\"tag\":\"type\",\"value\":\"browser\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"tt\",\"operator\":\"gt\",\"value\":1000}],\"group\":[\"tk\",\"req_path\",\"host\"],\"metric\":\"ta_req\",\"outputs\":[\"alert\"],\"select\":{\"doc_path\":\"#doc_path\",\"host\":\"#host\",\"req_path\":\"#req_path\",\"tk\":\"#tk\",\"type\":\"#type\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_browser_apdex","micro_service","app_browser","{\"alert_group\":\"{{tk}}-{{doc_path}}-{{host}}\",\"display_url_id\":\"micro_bi_position\",\"level\":\"WARNING\",\"recover\":\"false\"}","用户体验","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"tk\",\"value\":\"$tk\"},{\"operator\":\"eq\",\"tag\":\"type\",\"value\":\"browser\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"plt\",\"operator\":\"gt\",\"value\":3000}],\"group\":[\"tk\",\"doc_path\",\"host\"],\"metric\":\"ta_timing\",\"outputs\":[\"alert\"],\"select\":{\"doc_path\":\"#doc_path\",\"host\":\"#host\",\"tk\":\"#tk\",\"type\":\"#type\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_browser_host_req","micro_service","app_browser","{\"alert_group\":\"{{tk}}-{{host}}\",\"display_url_id\":\"micro_bi_domain\",\"level\":\"WARNING\",\"recover\":\"false\"}","域名访问性能","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"tk\",\"value\":\"$tk\"},{\"operator\":\"eq\",\"tag\":\"type\",\"value\":\"browser\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"plt\",\"operator\":\"gt\",\"value\":1000}],\"group\":[\"tk\",\"host\"],\"metric\":\"ta_timing\",\"outputs\":[\"alert\"],\"select\":{\"doc_path\":\"#doc_path\",\"host\":\"#host\",\"tk\":\"#tk\",\"type\":\"#type\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_browser_page_req","micro_service","app_browser","{\"alert_group\":\"{{tk}}-{{doc_path}}-{{host}}\",\"display_url_id\":\"micro_bi_page\",\"level\":\"WARNING\",\"recover\":\"false\"}","页面访问性能","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"tk\",\"value\":\"$tk\"},{\"operator\":\"eq\",\"tag\":\"type\",\"value\":\"browser\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"plt\",\"operator\":\"gt\",\"value\":1000}],\"group\":[\"tk\",\"doc_path\",\"host\"],\"metric\":\"ta_timing\",\"outputs\":[\"alert\"],\"select\":{\"doc_path\":\"#doc_path\",\"host\":\"#host\",\"tk\":\"#tk\",\"type\":\"#type\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_browser_script_error","micro_service","app_browser","{\"alert_group\":\"{{tk}}-{{doc_path}}-{{host}}\",\"display_url_id\":\"micro_bi_script\",\"level\":\"WARNING\",\"recover\":\"false\"}","脚本错误","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"tk\",\"value\":\"$tk\"},{\"operator\":\"eq\",\"tag\":\"type\",\"value\":\"browser\"}],\"functions\":[{\"aggregator\":\"sum\",\"field\":\"count\",\"operator\":\"gte\",\"value\":10}],\"group\":[\"tk\",\"doc_path\",\"host\"],\"metric\":\"ta_error\",\"outputs\":[\"alert\"],\"select\":{\"browser\":\"#browser\",\"count\":\"#count\",\"doc_path\":\"#doc_path\",\"host\":\"#host\",\"ip\":\"#ip\",\"source\":\"#source\",\"tk\":\"#tk\",\"type\":\"#type\",\"url\":\"#url\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_exception_count","micro_service","app_exception","{\"alert_group\":\"{{terminus_key}}-{{error_id}}\",\"display_url_id\":\"micro_error_detail\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{error_id}}\"}","应用错误次数","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"}],\"functions\":[{\"aggregator\":\"sum\",\"field\":\"count\",\"operator\":\"gte\",\"value\":20}],\"group\":[\"error_id\"],\"metric\":\"error_alert\",\"outputs\":[\"alert\"],\"select\":{\"application_id\":\"#application_id\",\"application_name\":\"#application_name\",\"class\":\"#class\",\"cluster_name\":\"#cluster_name\",\"error_id\":\"#error_id\",\"host_ip\":\"#host_ip\",\"instance_id\":\"#instance_id\",\"line\":\"#line\",\"method\":\"#method\",\"org_name\":\"#org_name\",\"project_id\":\"#project_id\",\"project_name\":\"#project_name\",\"runtime_id\":\"#runtime_id\",\"runtime_name\":\"#runtime_name\",\"service_name\":\"#service_name\",\"terminus_key\":\"#terminus_key\",\"type\":\"#type\",\"workspace\":\"#workspace\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_resource_container_cpu","micro_service","app_resource","{\"alert_group\":\"{{terminus_key}}-{{container_id}}\",\"display_url_id\":\"workbench_runtime\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","应用实例CPU使用率异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"cpu_usage_percent\",\"field_script\":\"function invoke(fields,tags){return fields.cpu_limit===0?fields.cpu_usage_percent:fields.cpu_usage_percent/fields.cpu_limit}\",\"operator\":\"gte\",\"value\":90},{\"aggregator\":\"max\",\"alias\":\"cpu_limit_value\",\"field\":\"cpu_limit\"},{\"aggregator\":\"max\",\"alias\":\"cpu_allocation_value\",\"field\":\"cpu_allocation\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"application_id\":\"#application_id\",\"application_name\":\"#application_name\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"instance_id\":\"#instance_id\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"project_id\":\"#project_id\",\"project_name\":\"#project_name\",\"runtime_id\":\"#runtime_id\",\"runtime_name\":\"#runtime_name\",\"service_name\":\"#service_name\",\"terminus_key\":\"#terminus_key\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_resource_container_mem","micro_service","app_resource","{\"alert_group\":\"{{terminus_key}}-{{container_id}}\",\"display_url_id\":\"workbench_runtime\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","应用实例内存使用率异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"mem_usage_percent\",\"operator\":\"gte\",\"value\":90},{\"aggregator\":\"max\",\"alias\":\"mem_usage_value\",\"field\":\"mem_usage\"},{\"aggregator\":\"max\",\"alias\":\"mem_limit_value\",\"field\":\"mem_limit\"},{\"aggregator\":\"max\",\"alias\":\"mem_max_usage_value\",\"field\":\"mem_max_usage\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"application_id\":\"#application_id\",\"application_name\":\"#application_name\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"instance_id\":\"#instance_id\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"project_id\":\"#project_id\",\"project_name\":\"#project_name\",\"runtime_id\":\"#runtime_id\",\"runtime_name\":\"#runtime_name\",\"service_name\":\"#service_name\",\"terminus_key\":\"#terminus_key\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_resource_container_oom","micro_service","app_resource","{\"alert_group\":\"{{terminus_key}}-{{container_id}}\",\"display_url_id\":\"workbench_runtime\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","应用实例OOM","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"}],\"functions\":[{\"aggregator\":\"values\",\"field\":\"oomkilled\",\"operator\":\"contains\",\"value\":true}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"application_id\":\"#application_id\",\"application_name\":\"#application_name\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"instance_id\":\"#instance_id\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"project_id\":\"#project_id\",\"project_name\":\"#project_name\",\"runtime_id\":\"#runtime_id\",\"runtime_name\":\"#runtime_name\",\"service_name\":\"#service_name\",\"terminus_key\":\"#terminus_key\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_resource_jvm_gc_count","micro_service","app_resource","{\"alert_group\":\"{{terminus_key}}-{{instance_id}}\",\"display_url_id\":\"micro_jvm\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{instance_id}}\"}","应用JVM GC次数","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"name\",\"value\":\"concurrentmarksweep\"},{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"},{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"sum\",\"field\":\"count\",\"operator\":\"gte\",\"value\":5}],\"group\":[\"instance_id\"],\"metric\":\"jvm_gc\",\"outputs\":[\"alert\"],\"select\":{\"application_id\":\"#application_id\",\"application_name\":\"#application_name\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"instance_id\":\"#instance_id\",\"org_name\":\"#org_name\",\"project_id\":\"#project_id\",\"project_name\":\"#project_name\",\"runtime_id\":\"#runtime_id\",\"runtime_name\":\"#runtime_name\",\"service_name\":\"#service_name\",\"terminus_key\":\"#terminus_key\",\"workspace\":\"#workspace\"},\"window\":3}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_resource_jvm_gc_time","micro_service","app_resource","{\"alert_group\":\"{{terminus_key}}-{{instance_id}}\",\"display_url_id\":\"micro_jvm\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{instance_id}}\"}","应用JVM GC 耗时","{\"condition\":\"or\",\"filters\":[{\"operator\":\"eq\",\"tag\":\"name\",\"value\":\"concurrentmarksweep\"},{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"},{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"time_value\",\"field\":\"time\",\"operator\":\"gte\",\"value\":400},{\"aggregator\":\"sum\",\"field\":\"time\",\"operator\":\"gte\",\"value\":1000}],\"group\":[\"instance_id\"],\"metric\":\"jvm_gc\",\"outputs\":[\"alert\"],\"select\":{\"application_id\":\"#application_id\",\"application_name\":\"#application_name\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"instance_id\":\"#instance_id\",\"org_name\":\"#org_name\",\"project_id\":\"#project_id\",\"project_name\":\"#project_name\",\"runtime_id\":\"#runtime_id\",\"runtime_name\":\"#runtime_name\",\"service_name\":\"#service_name\",\"terminus_key\":\"#terminus_key\",\"workspace\":\"#workspace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_resource_jvm_heap","micro_service","app_resource","{\"alert_group\":\"{{terminus_key}}-{{instance_id}}\",\"display_url_id\":\"micro_jvm\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{instance_id}}\"}","应用JVM堆内存","{\"condition\":\"and\",\"filters\":[{\"operator\":\"eq\",\"tag\":\"name\",\"value\":\"heap_memory\"},{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"},{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"usage_percent\",\"field_script\":\"function invoke(field, tag){ return field.used / field.max * 100; }\",\"operator\":\"gte\",\"value\":75},{\"aggregator\":\"max\",\"alias\":\"used_value\",\"field\":\"used\"},{\"aggregator\":\"max\",\"alias\":\"max_value\",\"field\":\"max\"}],\"group\":[\"instance_id\"],\"metric\":\"jvm_memory\",\"outputs\":[\"alert\"],\"select\":{\"application_id\":\"#application_id\",\"application_name\":\"#application_name\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"instance_id\":\"#instance_id\",\"org_name\":\"#org_name\",\"project_id\":\"#project_id\",\"project_name\":\"#project_name\",\"runtime_id\":\"#runtime_id\",\"runtime_name\":\"#runtime_name\",\"service_name\":\"#service_name\",\"terminus_key\":\"#terminus_key\",\"workspace\":\"#workspace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_resource_nodejs_heap","micro_service","app_resource","{\"alert_group\":\"{{terminus_key}}-{{instance_id}}\",\"display_url_id\":\"micro_nodejs\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{instance_id}}\"}","应用NodeJS堆内存使用率","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"},{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"usage_percent\",\"field_script\":\"function invoke(field, tag){ if(!field.max) { return 0; } return field.rss / field.max * 100; }\",\"operator\":\"gte\",\"value\":75},{\"aggregator\":\"max\",\"alias\":\"heap_used_value\",\"field\":\"heap_used\"},{\"aggregator\":\"max\",\"alias\":\"heap_total_value\",\"field\":\"heap_total\"},{\"aggregator\":\"max\",\"alias\":\"rss_value\",\"field\":\"rss\"},{\"aggregator\":\"max\",\"alias\":\"max_value\",\"field\":\"max\"}],\"group\":[\"instance_id\"],\"metric\":\"nodejs_memory\",\"outputs\":[\"alert\"],\"select\":{\"application_id\":\"#application_id\",\"application_name\":\"#application_name\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"instance_id\":\"#instance_id\",\"org_name\":\"#org_name\",\"project_id\":\"#project_id\",\"project_name\":\"#project_name\",\"runtime_id\":\"#runtime_id\",\"runtime_name\":\"#runtime_name\",\"service_name\":\"#service_name\",\"terminus_key\":\"#terminus_key\",\"workspace\":\"#workspace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_status_browser","micro_service","app_status","{\"alert_group\":\"{{terminus_key}}-{{metric_id}}\",\"display_url_id\":\"micro_status_detail\",\"level\":\"ERROR\",\"recover\":\"false\",\"tickets_metric_key\":\"{{metric_id}}\"}","页面内容改变","{\"alias\":\"status_page_browser\",\"filters\":[{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"},{\"operator\":\"eq\",\"tag\":\"type\",\"value\":\"browser\"}],\"functions\":[{\"aggregator\":\"min\",\"field\":\"diff_screenshot\",\"operator\":\"eq\",\"value\":false}],\"group\":[\"metric\"],\"metric\":\"status_page\",\"outputs\":[\"alert\"],\"select\":{\"metric_id\":\"#metric\",\"project_id\":\"#project_id\",\"project_name\":\"#project_name\",\"status_metric_name\":\"#metric_name\",\"terminus_key\":\"#terminus_key\",\"type\":\"#type\",\"url\":\"#url\",\"workspace\":\"#env\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_status_code","micro_service","app_status","{\"alert_group\":\"{{terminus_key}}-{{metric_id}}\",\"display_url_id\":\"micro_status_detail\",\"level\":\"ERROR\",\"recover\":\"true\",\"tickets_metric_key\":\"{{metric_id}}\"}","主动监控HTTP状态异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"},{\"operator\":\"eq\",\"tag\":\"type\",\"value\":\"http\"}],\"functions\":[{\"aggregator\":\"sum\",\"field\":\"retry\"},{\"aggregator\":\"min\",\"field\":\"code\",\"operator\":\"gte\",\"value\":400}],\"group\":[\"metric\"],\"metric\":\"status_page\",\"outputs\":[\"alert\"],\"select\":{\"metric_id\":\"#metric\",\"project_id\":\"#project_id\",\"project_name\":\"#project_name\",\"status_metric_name\":\"#metric_name\",\"terminus_key\":\"#terminus_key\",\"type\":\"#type\",\"url\":\"#url\",\"workspace\":\"#env\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_transaction_http_path_error","micro_service","app_transaction","{\"alert_group\":\"{{target_terminus_key}}-{{target_runtime_id}}-{{target_service_name}}-{{http_path}}-{{http_method}}\",\"display_url_id\":\"micro_si_web\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{target_application_id}}\"}","服务接口HTTP错误率异常","{\"condition\":\"and\",\"filters\":[{\"operator\":\"eq\",\"tag\":\"target_terminus_key\",\"value\":\"$terminus_key\"}],\"functions\":[{\"aggregator\":\"sum\",\"field\":\"elapsed_count\",\"operator\":\"gte\",\"value\":10},{\"aggregator\":\"sum\",\"field\":\"error_count\",\"field_script\":\"function invoke(field, tag){ if(field.http_status_code_mean \\u003c 500) { return 0; } return field.elapsed_count; }\"},{\"aggregator\":\"value\",\"field\":\"error_percent\",\"field_script\":\"function invoke(field, tag){ if(!field.elapsed_count_sum) return 0; return field.elapsed_count_sum === 0 ? 0 : (field.error_count_sum / field.elapsed_count_sum * 100);}\",\"operator\":\"gte\",\"trigger\":\"aggregated\",\"value\":50}],\"group\":[\"target_runtime_id\",\"target_service_name\",\"http_path\",\"http_method\"],\"metric\":\"application_http\",\"outputs\":[\"alert\"],\"select\":{\"application_name\":\"#target_application_name\",\"http_method\":\"#http_method\",\"http_path\":\"#http_path\",\"http_url\":\"#http_url\",\"project_id\":\"#target_project_id\",\"project_name\":\"#target_project_name\",\"runtime_id\":\"#target_runtime_id\",\"runtime_name\":\"#target_runtime_name\",\"service_name\":\"#target_service_name\",\"terminus_key\":\"#target_terminus_key\",\"workspace\":\"#target_workspace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_transaction_http_path_rt","micro_service","app_transaction","{\"alert_group\":\"{{target_terminus_key}}-{{target_runtime_id}}-{{target_service_name}}-{{http_path}}-{{http_method}}\",\"display_url_id\":\"micro_si_web\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{target_application_id}}\"}","服务接口HTTP慢事务异常","{\"condition\":\"and\",\"filters\":[{\"operator\":\"eq\",\"tag\":\"target_terminus_key\",\"value\":\"$terminus_key\"}],\"functions\":[{\"aggregator\":\"sum\",\"field\":\"elapsed\",\"field_script\":\"function invoke(field, tag){ return field.elapsed_sum / 1000000; }\"},{\"aggregator\":\"sum\",\"field\":\"elapsed_count\",\"operator\":\"gte\",\"value\":10},{\"aggregator\":\"value\",\"field\":\"elapsed_avg\",\"field_script\":\"function invoke(field, tag){ if(!field.elapsed_count_sum) return 0; return field.elapsed_count_sum === 0 ? 0 : (field.elapsed_sum / field.elapsed_count_sum);}\",\"operator\":\"gte\",\"trigger\":\"aggregated\",\"value\":3000}],\"group\":[\"target_runtime_id\",\"target_service_name\",\"http_path\",\"http_method\"],\"metric\":\"application_http\",\"outputs\":[\"alert\"],\"select\":{\"application_name\":\"#target_application_name\",\"http_method\":\"#http_method\",\"http_path\":\"#http_path\",\"http_url\":\"#http_url\",\"project_id\":\"#target_project_id\",\"project_name\":\"#target_project_name\",\"runtime_id\":\"#target_runtime_id\",\"runtime_name\":\"#target_runtime_name\",\"service_name\":\"#target_service_name\",\"terminus_key\":\"#target_terminus_key\",\"workspace\":\"#target_workspace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_transaction_http_service_error","micro_service","app_transaction","{\"alert_group\":\"{{target_terminus_key}}-{{target_runtime_id}}-{{target_service_name}}\",\"display_url_id\":\"micro_si_web\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{target_application_id}}\"}","服务HTTP错误率异常","{\"condition\":\"and\",\"filters\":[{\"operator\":\"eq\",\"tag\":\"target_terminus_key\",\"value\":\"$terminus_key\"}],\"functions\":[{\"aggregator\":\"sum\",\"field\":\"elapsed_count\"},{\"aggregator\":\"sum\",\"field\":\"error_count\",\"field_script\":\"function invoke(field, tag){ if(field.http_status_code_mean \\u003c 500) { return 0; } return field.elapsed_count; }\"},{\"aggregator\":\"value\",\"field\":\"error_percent\",\"field_script\":\"function invoke(field, tag){ if(!field.elapsed_count_sum) return 0; return field.elapsed_count_sum === 0 ? 0 : (field.error_count_sum / field.elapsed_count_sum * 100);}\",\"operator\":\"gte\",\"trigger\":\"aggregated\",\"value\":30}],\"group\":[\"target_runtime_id\",\"target_service_name\"],\"metric\":\"application_http\",\"outputs\":[\"alert\"],\"select\":{\"application_name\":\"#target_application_name\",\"project_id\":\"#target_project_id\",\"project_name\":\"#target_project_name\",\"runtime_id\":\"#target_runtime_id\",\"runtime_name\":\"#target_runtime_name\",\"service_name\":\"#target_service_name\",\"terminus_key\":\"#target_terminus_key\",\"workspace\":\"#target_workspace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("app_transaction_http_service_rt","micro_service","app_transaction","{\"alert_group\":\"{{target_terminus_key}}-{{target_runtime_id}}-{{target_service_name}}\",\"display_url_id\":\"micro_si_web\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{target_application_id}}\"}","服务HTTP慢事务异常","{\"condition\":\"and\",\"filters\":[{\"operator\":\"eq\",\"tag\":\"target_terminus_key\",\"value\":\"$terminus_key\"}],\"functions\":[{\"aggregator\":\"sum\",\"field\":\"elapsed\",\"field_script\":\"function invoke(field, tag){ return field.elapsed_sum / 1000000; }\"},{\"aggregator\":\"sum\",\"field\":\"elapsed_count\"},{\"aggregator\":\"value\",\"field\":\"elapsed_avg\",\"field_script\":\"function invoke(field, tag){ if(!field.elapsed_count_sum) return 0; return field.elapsed_count_sum === 0 ? 0 : (field.elapsed_sum / field.elapsed_count_sum);}\",\"operator\":\"gte\",\"trigger\":\"aggregated\",\"value\":1000}],\"group\":[\"target_runtime_id\",\"target_service_name\"],\"metric\":\"application_http\",\"outputs\":[\"alert\"],\"select\":{\"application_name\":\"#target_application_name\",\"project_id\":\"#target_project_id\",\"project_name\":\"#target_project_name\",\"runtime_id\":\"#target_runtime_id\",\"runtime_name\":\"#target_runtime_name\",\"service_name\":\"#target_service_name\",\"terminus_key\":\"#target_terminus_key\",\"workspace\":\"#target_workspace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("slave_dly_alert","org","custom_addon","{\"alert_group\":\"{{cluster_name}}-{{addon_id}}\",\"level\":\"WARNING\",\"recover\":\"true\"}","MySQL SLAVE DELAY ALERT","{\"condition\":\"or\",\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"is_slave\",\"value\":\"true\"}],\"functions\":[{\"aggregator\":\"values\",\"field\":\"slave_slave_sql_running_state\",\"field_script\":\"function invoke(fields,tags){if (fields.slave_slave_sql_running_state == 'Slave has read all relay log; waiting for more updates') {return 'no delay'} return 'delay';}\",\"operator\":\"all\",\"value\":\"delay\"},{\"aggregator\":\"max\",\"field\":\"slave_seconds_behind_master\",\"operator\":\"gt\",\"value\":1800}],\"group\":[\"addon_id\",\"server\"],\"metric\":\"mysql\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"cluster_name\":\"#cluster_name\",\"org_name\":\"#org_name\",\"server_id\":\"#server\"},\"window\":30}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("slave_sync_alert","org","custom_addon","{\"alert_group\":\"{{cluster_name}}-{{addon_id}}\",\"level\":\"WARNING\",\"recover\":\"true\"}","MySQL SLAVE SYNC ALERT","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"is_slave\",\"value\":\"true\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"slave_slave_sync_ok_value\",\"field\":\"slave_slave_sync_ok\",\"field_script\":\"function invoke(fields,tags){if (fields.slave_slave_io_running == 0 || fields.slave_slave_sql_running == 0) {return 0} return 1}\",\"operator\":\"eq\",\"value\":0},{\"aggregator\":\"max\",\"alias\":\"slave_slave_io_running_value\",\"field\":\"slave_slave_io_running\"},{\"aggregator\":\"max\",\"alias\":\"slave_slave_sql_running_value\",\"field\":\"slave_slave_sql_running\"}],\"group\":[\"addon_id\",\"server\"],\"metric\":\"mysql\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"cluster_name\":\"#cluster_name\",\"org_name\":\"#org_name\",\"server_id\":\"#server\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_cassandra_gc_count","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{addon_id}}\",\"display_url_id\":\"org_addon\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{addon_id}}\"}","平台中间件Cassandra GC次数异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"addon_id\",\"value\":\"cassandra\"},{\"operator\":\"like\",\"tag\":\"name\",\"value\":\"Old\"}],\"functions\":[{\"aggregator\":\"min\",\"field\":\"CollectionCount_min\",\"field_script\":\"function invoke(fields,tags){return fields.CollectionCount;}\"},{\"aggregator\":\"max\",\"field\":\"CollectionCount_max\",\"field_script\":\"function invoke(fields,tags){return fields.CollectionCount;}\"},{\"aggregator\":\"value\",\"field\":\"CollectionCount_win\",\"field_script\":\"function invoke(fields,tags){return fields.CollectionCount_max-fields.CollectionCount_min;}\",\"operator\":\"gte\",\"trigger\":\"aggregated\",\"value\":10}],\"group\":[\"cluster_name\",\"node_id\"],\"metrics\":[\"addon_java_GarbageCollector\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"node_host\":\"#jolokia_host\",\"org_name\":\"#org_name\"},\"window\":3}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_cassandra_gc_time","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{addon_id}}\",\"display_url_id\":\"org_addon\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{addon_id}}\"}","平台中间件Cassandra GC耗时异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"addon_id\",\"value\":\"cassandra\"},{\"operator\":\"like\",\"tag\":\"name\",\"value\":\"Old\"}],\"functions\":[{\"aggregator\":\"min\",\"field\":\"CollectionTime_min\",\"field_script\":\"function invoke(fields,tags){return fields.CollectionTime;}\"},{\"aggregator\":\"max\",\"field\":\"CollectionTime_max\",\"field_script\":\"function invoke(fields,tags){return fields.CollectionTime;}\"},{\"aggregator\":\"value\",\"field\":\"CollectionTime_win\",\"field_script\":\"function invoke(fields,tags){return fields.CollectionTime_max-fields.CollectionTime_min;}\",\"operator\":\"gte\",\"trigger\":\"aggregated\",\"value\":15000}],\"group\":[\"cluster_name\",\"node_id\"],\"metrics\":[\"addon_java_GarbageCollector\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"node_host\":\"#jolokia_host\",\"org_name\":\"#org_name\"},\"window\":3}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_container_cpu","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","平台中间件实例CPU状态","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"pod_namespace\",\"value\":\"default\"},{\"operator\":\"any\",\"tag\":\"addon_id\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"cpu_usage_percent\",\"field_script\":\"function invoke(fields,tags){return fields.cpu_limit===0?fields.cpu_usage_percent:fields.cpu_usage_percent/fields.cpu_limit}\",\"operator\":\"gte\",\"value\":95},{\"aggregator\":\"max\",\"alias\":\"cpu_limit_value\",\"field\":\"cpu_limit\"},{\"aggregator\":\"max\",\"alias\":\"cpu_allocation_value\",\"field\":\"cpu_allocation\"}],\"group\":[\"cluster_name\",\"container_id\"],\"metrics\":[\"docker_container_summary\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":2}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_container_exit","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"display_url_id\":\"org_pod\",\"level\":\"FATAL\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","平台中间件异常退出","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"pod_namespace\",\"value\":\"default\"},{\"operator\":\"any\",\"tag\":\"addon_id\"}],\"functions\":[{\"aggregator\":\"max\",\"field\":\"exitcode\",\"operator\":\"gt\",\"value\":0},{\"aggregator\":\"max\",\"field\":\"oomkilled\"},{\"aggregator\":\"value\",\"field\":\"pid\"},{\"aggregator\":\"max\",\"field\":\"finished_at\",\"field_script\":\"function invoke(fields,tags){if(fields.finished_at!=null\\u0026\\u0026fields.finished_at!=undefined) return fields.finished_at/1000000;return 0}\"},{\"aggregator\":\"max\",\"field\":\"started_at\",\"field_script\":\"function invoke(fields,tags){if(fields.started_at!=null\\u0026\\u0026fields.started_at!=undefined) return fields.started_at/1000000;return 0}\"},{\"aggregator\":\"value\",\"field\":\"finished_at\",\"field_script\":\"function invoke(fields,tags){if(fields.finished_at_max\\u003e0) return fields.finished_at_max;return '-'}\",\"trigger\":\"aggregated\"},{\"aggregator\":\"value\",\"field\":\"started_at\",\"field_script\":\"function invoke(fields,tags){if(fields.started_at_max\\u003e0) return fields.started_at_max;return '-'}\",\"trigger\":\"aggregated\"},{\"aggregator\":\"value\",\"field\":\"terminated_reason\",\"field_script\":\"function invoke(fields,tags){if(fields.oomkilled) return 'Out Of Memory';return 'Error Exit Code '+fields.exitcode_max;}\",\"trigger\":\"aggregated\"}],\"group\":[\"cluster_name\",\"pod_namespace\",\"pod_name\"],\"metrics\":[\"docker_container_summary\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_container_mem","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","平台中间件实例内存状态","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"pod_namespace\",\"value\":\"default\"},{\"operator\":\"any\",\"tag\":\"addon_id\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"mem_usage_percent\",\"operator\":\"gt\",\"value\":80},{\"aggregator\":\"max\",\"alias\":\"mem_usage_value\",\"field\":\"mem_usage\"},{\"aggregator\":\"max\",\"alias\":\"mem_limit_value\",\"field\":\"mem_limit\"},{\"aggregator\":\"max\",\"alias\":\"mem_max_value\",\"field\":\"mem_max_usage\"},{\"aggregator\":\"max\",\"alias\":\"mem_allocation_value\",\"field\":\"mem_allocation\"}],\"group\":[\"cluster_name\",\"container_id\"],\"metrics\":[\"docker_container_summary\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":2}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_container_ready","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{daemonset_name}}-{{statefulset_name}}-{{deployment_name}}\",\"level\":\"FATAL\",\"recover\":\"true\",\"tickets_metric_key\":\"{{daemonset_name}}-{{statefulset_name}}-{{deployment_name}}\"}","平台中间件实例Ready状态异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"namespace\",\"value\":\"default\"},{\"operator\":\"any\",\"tag\":\"addon_id\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"not_ready_value\",\"field\":\"not_ready\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return fields.number_unavailable}else{if(tags.statefulset_name){return fields.replicas-fields.replicas_ready}else{if(tags.deployment_name){return fields.replicas_unavailable}}}return 0}\",\"operator\":\"gt\",\"value\":0},{\"aggregator\":\"max\",\"alias\":\"ready_value\",\"field\":\"ready_value\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return fields.number_available}else{if(tags.statefulset_name){return fields.replicas_ready}else{if(tags.deployment_name){return fields.replicas_available}}}return 0}\"},{\"aggregator\":\"max\",\"alias\":\"total_value\",\"field\":\"total_value\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return fields.number_unavailable+fields.number_available}else{if(tags.statefulset_name){return fields.replicas}else{if(tags.deployment_name){return fields.replicas}}}return 0}\"},{\"aggregator\":\"value\",\"alias\":\"resource_name_value\",\"field\":\"resource_name_value\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return tags.daemonset_name}else{if(tags.statefulset_name){return tags.statefulset_name}else{if(tags.deployment_name){return tags.deployment_name}}}return null};\"}],\"group\":[\"cluster_name\",\"namespace\",\"daemonset_name\",\"statefulset_name\",\"deployment_name\"],\"metrics\":[\"kubernetes_daemonset\",\"kubernetes_statefulset\",\"kubernetes_deployment\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"cluster_name\":\"#cluster_name\",\"daemonset_name\":\"#daemonset_name\",\"deployment_name\":\"#deployment_name\",\"namespace\":\"#namespace\",\"org_name\":\"#org_name\",\"statefulset_name\":\"#statefulset_name\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_elasticsearch_gc_count","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{addon_id}}\",\"display_url_id\":\"org_addon\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{addon_id}}\"}","平台中间件Elasticsearch GC次数异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"addon_id\",\"value\":\"elasticsearch\"}],\"functions\":[{\"aggregator\":\"min\",\"field\":\"gc_collectors_old_collection_count\"},{\"aggregator\":\"max\",\"field\":\"gc_collectors_old_collection_count\"},{\"aggregator\":\"value\",\"field\":\"gc_collectors_old_collection_count_win\",\"field_script\":\"function invoke(fields,tags){return fields.gc_collectors_old_collection_count_max-fields.gc_collectors_old_collection_count_min;}\",\"operator\":\"gte\",\"trigger\":\"aggregated\",\"value\":10}],\"group\":[\"cluster_name\",\"node_id\"],\"metrics\":[\"elasticsearch_jvm\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"node_host\":\"#node_host\",\"node_id\":\"#node_id\",\"node_name\":\"#node_name\",\"org_name\":\"#org_name\"},\"window\":3}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_elasticsearch_gc_time","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{addon_id}}\",\"display_url_id\":\"org_addon\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{addon_id}}\"}","平台中间件Elasticsearch GC耗时异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"addon_id\",\"value\":\"elasticsearch\"}],\"functions\":[{\"aggregator\":\"min\",\"field\":\"gc_collectors_old_collection_time_in_millis\"},{\"aggregator\":\"max\",\"field\":\"gc_collectors_old_collection_time_in_millis\"},{\"aggregator\":\"value\",\"field\":\"gc_collectors_old_collection_time_in_millis_win\",\"field_script\":\"function invoke(fields,tags){return fields.gc_collectors_old_collection_time_in_millis_max-fields.gc_collectors_old_collection_time_in_millis_min;}\",\"operator\":\"gte\",\"trigger\":\"aggregated\",\"value\":15000}],\"group\":[\"cluster_name\",\"node_id\"],\"metrics\":[\"elasticsearch_jvm\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"node_host\":\"#node_host\",\"node_id\":\"#node_id\",\"node_name\":\"#node_name\",\"org_name\":\"#org_name\"},\"window\":3}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_kafka_gc_count","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{addon_id}}\",\"display_url_id\":\"org_addon\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{addon_id}}\"}","平台中间件Kafka GC次数异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"addon_id\",\"value\":\"kafka\"},{\"operator\":\"like\",\"tag\":\"name\",\"value\":\"Old\"}],\"functions\":[{\"aggregator\":\"min\",\"field\":\"CollectionCount\"},{\"aggregator\":\"max\",\"field\":\"CollectionCount\"},{\"aggregator\":\"value\",\"field\":\"CollectionCount_win\",\"field_script\":\"function invoke(fields,tags){return fields.CollectionCount_max-fields.CollectionCount_min;}\",\"operator\":\"gte\",\"trigger\":\"aggregated\",\"value\":10}],\"group\":[\"cluster_name\",\"node_id\"],\"metrics\":[\"addon_java_GarbageCollector\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"node_host\":\"#jolokia_host\",\"org_name\":\"#org_name\"},\"window\":3}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_kafka_gc_time","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{addon_id}}\",\"display_url_id\":\"org_addon\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{addon_id}}\"}","平台中间件Kafka GC耗时异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"addon_id\",\"value\":\"kafka\"},{\"operator\":\"like\",\"tag\":\"name\",\"value\":\"Old\"}],\"functions\":[{\"aggregator\":\"min\",\"field\":\"CollectionTime\"},{\"aggregator\":\"max\",\"field\":\"CollectionTime\"},{\"aggregator\":\"value\",\"field\":\"CollectionTime_win\",\"field_script\":\"function invoke(fields,tags){return fields.CollectionTime_max-fields.CollectionTime_min;}\",\"operator\":\"gte\",\"trigger\":\"aggregated\",\"value\":15000}],\"group\":[\"cluster_name\",\"node_id\"],\"metrics\":[\"addon_java_GarbageCollector\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"node_host\":\"#jolokia_host\",\"org_name\":\"#org_name\"},\"window\":3}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_addon_kafka_lag","org","dice_addon","{\"alert_group\":\"{{cluster_name}}-{{group}}-{{topic}}\",\"display_url_id\":\"org_addon\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{group}}-{{topic}}\"}","平台中间件kafka消费堆积","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"addon_id\",\"value\":\"kafka\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"lag\",\"operator\":\"gte\",\"value\":100000},{\"aggregator\":\"avg\",\"field\":\"consume_rate_per_sec\"},{\"aggregator\":\"avg\",\"field\":\"produce_rate_per_sec\"}],\"group\":[\"cluster_name\",\"addon_id\",\"group\",\"topic\"],\"metrics\":[\"kafka_consumer\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"group\":\"#group\",\"org_name\":\"#org_name\",\"topic\":\"#topic\"},\"window\":3}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_component_container_cpu","org","dice_component","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","平台组件实例CPU状态","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"pod_namespace\",\"value\":\"default\"},{\"operator\":\"any\",\"tag\":\"component_name\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"cpu_usage_percent\",\"field_script\":\"function invoke(fields,tags){return fields.cpu_limit===0?fields.cpu_usage_percent:fields.cpu_usage_percent/fields.cpu_limit}\",\"operator\":\"gte\",\"value\":95},{\"aggregator\":\"max\",\"alias\":\"cpu_limit_value\",\"field\":\"cpu_limit\"},{\"aggregator\":\"max\",\"alias\":\"cpu_allocation_value\",\"field\":\"cpu_allocation\"}],\"group\":[\"cluster_name\",\"container_id\"],\"metrics\":[\"docker_container_summary\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"component_name\":\"#component_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":2}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_component_container_exit","org","dice_component","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"display_url_id\":\"org_pod\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","平台组件异常退出","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"pod_namespace\",\"value\":\"default\"},{\"operator\":\"any\",\"tag\":\"component_name\"}],\"functions\":[{\"aggregator\":\"max\",\"field\":\"exitcode\",\"operator\":\"gt\",\"value\":0},{\"aggregator\":\"max\",\"field\":\"oomkilled\"},{\"aggregator\":\"value\",\"field\":\"pid\"},{\"aggregator\":\"max\",\"field\":\"finished_at\",\"field_script\":\"function invoke(fields,tags){if(fields.finished_at!=null\\u0026\\u0026fields.finished_at!=undefined) return fields.finished_at/1000000;return 0}\"},{\"aggregator\":\"max\",\"field\":\"started_at\",\"field_script\":\"function invoke(fields,tags){if(fields.started_at!=null\\u0026\\u0026fields.started_at!=undefined) return fields.started_at/1000000;return 0}\"},{\"aggregator\":\"value\",\"field\":\"finished_at\",\"field_script\":\"function invoke(fields,tags){if(fields.finished_at_max\\u003e0) return fields.finished_at_max;return '-'}\",\"trigger\":\"aggregated\"},{\"aggregator\":\"value\",\"field\":\"started_at\",\"field_script\":\"function invoke(fields,tags){if(fields.started_at_max\\u003e0) return fields.started_at_max;return '-'}\",\"trigger\":\"aggregated\"},{\"aggregator\":\"value\",\"field\":\"terminated_reason\",\"field_script\":\"function invoke(fields,tags){if(fields.oomkilled) return 'Out Of Memory';return 'Error Exit Code '+fields.exitcode_max;}\",\"trigger\":\"aggregated\"}],\"group\":[\"cluster_name\",\"container_id\"],\"metrics\":[\"docker_container_summary\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"component_name\":\"#component_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_component_container_mem","org","dice_component","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"false\",\"tickets_metric_key\":\"{{container_id}}\"}","平台组件实例内存状态","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"pod_namespace\",\"value\":\"default\"},{\"operator\":\"any\",\"tag\":\"component_name\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"mem_usage_percent\",\"operator\":\"gt\",\"value\":70},{\"aggregator\":\"max\",\"alias\":\"mem_usage_value\",\"field\":\"mem_usage\"},{\"aggregator\":\"max\",\"alias\":\"mem_limit_value\",\"field\":\"mem_limit\"},{\"aggregator\":\"max\",\"alias\":\"mem_max_usage_value\",\"field\":\"mem_max_usage\"},{\"aggregator\":\"max\",\"alias\":\"mem_allocation_value\",\"field\":\"mem_allocation\"}],\"group\":[\"cluster_name\",\"container_id\"],\"metrics\":[\"docker_container_summary\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"component_name\":\"#component_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":2}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_component_container_ready","org","dice_component","{\"alert_group\":\"{{cluster_name}}-{{daemonset_name}}-{{statefulset_name}}-{{deployment_name}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{daemonset_name}}-{{statefulset_name}}-{{deployment_name}}\"}","平台组件实例Ready状态异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"namespace\",\"value\":\"default\"},{\"operator\":\"any\",\"tag\":\"component_name\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"not_ready_value\",\"field\":\"not_ready\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return fields.number_unavailable}else{if(tags.statefulset_name){return fields.replicas-fields.replicas_ready}else{if(tags.deployment_name){return fields.replicas_unavailable}}}return 0}\",\"operator\":\"gt\",\"value\":0},{\"aggregator\":\"max\",\"alias\":\"ready_value\",\"field\":\"ready_value\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return fields.number_available}else{if(tags.statefulset_name){return fields.replicas_ready}else{if(tags.deployment_name){return fields.replicas_available}}}return 0}\"},{\"aggregator\":\"max\",\"alias\":\"total_value\",\"field\":\"total_value\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return fields.number_unavailable+fields.number_available}else{if(tags.statefulset_name){return fields.replicas}else{if(tags.deployment_name){return fields.replicas}}}return 0}\"},{\"aggregator\":\"value\",\"alias\":\"resource_name_value\",\"field\":\"resource_name_value\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return tags.daemonset_name}else{if(tags.statefulset_name){return tags.statefulset_name}else{if(tags.deployment_name){return tags.deployment_name}}}return null};\"}],\"group\":[\"cluster_name\",\"namespace\",\"daemonset_name\",\"statefulset_name\",\"deployment_name\"],\"metrics\":[\"kubernetes_daemonset\",\"kubernetes_statefulset\",\"kubernetes_deployment\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"component_name\":\"#component_name\",\"daemonset_name\":\"#daemonset_name\",\"deployment_name\":\"#deployment_name\",\"namespace\":\"#namespace\",\"org_name\":\"#org_name\",\"statefulset_name\":\"#statefulset_name\"},\"window\":3}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_component_flink_checkpoint_duration","org","dice_component","{\"alert_group\":\"{{cluster_name}}-{{container_id}}-{{job_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}-{{job_id}}\"}","平台组件Flink任务checkpoint延迟异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"lastCheckpointDuration_value\",\"field\":\"lastCheckpointDuration\",\"operator\":\"gte\",\"value\":3000}],\"group\":[\"cluster_name\",\"container_id\",\"job_id\"],\"metric\":\"flink_jm_job\",\"outputs\":[\"alert\"],\"select\":{\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"job_id\":\"#job_id\",\"org_name\":\"#org_name\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_component_flink_throughput","org","dice_component","{\"alert_group\":\"{{cluster_name}}-{{container_id}}-{{job_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}-{{job_id}}\"}","平台组件Flink吞吐量异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"numRecordsOutPerSecond_count_value\",\"field\":\"numRecordsOutPerSecond_count\",\"operator\":\"eq\",\"value\":0}],\"group\":[\"cluster_name\",\"container_id\",\"job_id\",\"task_id\",\"subtask_index\",\"operator_id\"],\"metric\":\"flink_tm_operator\",\"outputs\":[\"alert\"],\"select\":{\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"job_id\":\"#job_id\",\"operator_id\":\"#operator_id\",\"org_name\":\"#org_name\",\"subtask_index\":\"#subtask_index\",\"tm_id\":\"#tm_id\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_component_gfs_status","org","dice_component","{\"alert_group\":\"{{cluster_name}}\",\"level\":\"FATAL\",\"recover\":\"true\",\"tickets_metric_key\":\"{{cluster_name}}\"}","平台组件网盘不可用告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"values\",\"field\":\"status\",\"operator\":\"all\",\"value\":\"Disconnected\"}],\"group\":[\"cluster_name\",\"host_ip\"],\"metric\":\"glusterfs\",\"outputs\":[\"alert\"],\"select\":{\"cluster_name\":\"#cluster_name\",\"component_name\":\"#component_name\",\"host_ip\":\"#host_ip\",\"node_uuid\":\"#node_uuid\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("dice_component_log_protector","org","dice_component","{\"alert_group\":\"{{cluster_name}}\",\"level\":\"INFO\",\"recover\":\"false\",\"tickets_metric_key\":\"{{cluster_name}}\"}","平台组价日志存储保护器状态变化","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"field\",\"value\":\"log_store_protector_triggered\"}],\"functions\":[{\"aggregator\":\"value\",\"field\":\"triggered\",\"operator\":\"eq\",\"value\":1}],\"group\":[\"cluster_name\"],\"metric\":\"dice_monitor\",\"outputs\":[\"alert\"],\"select\":{\"cluster_name\":\"#cluster_name\",\"cur_level\":\"#cur_level\",\"org_name\":\"#org_name\",\"pre_level\":\"#pre_level\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("kubernetes_instance_cpu","org","kubernetes","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","kubernetes组件实例CPU状态","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"pod_namespace\",\"value\":\"kube-system\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"cpu_usage_percent\",\"field_script\":\"function invoke(fields,tags){return fields.cpu_limit===0?fields.cpu_usage_percent:fields.cpu_usage_percent/fields.cpu_limit}\",\"operator\":\"gte\",\"value\":95},{\"aggregator\":\"max\",\"alias\":\"cpu_limit_value\",\"field\":\"cpu_limit\"},{\"aggregator\":\"max\",\"alias\":\"cpu_allocation_value\",\"field\":\"cpu_allocation\"}],\"group\":[\"cluster_name\",\"container_id\"],\"metrics\":[\"docker_container_summary\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"component_name\":\"#pod_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":2}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("kubernetes_instance_exit","org","kubernetes","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"display_url_id\":\"org_pod\",\"level\":\"FATAL\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","kubernetes组件异常退出","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"pod_namespace\",\"value\":\"kube-system\"}],\"functions\":[{\"aggregator\":\"max\",\"field\":\"exitcode\",\"operator\":\"gt\",\"value\":0},{\"aggregator\":\"max\",\"field\":\"oomkilled\"},{\"aggregator\":\"value\",\"field\":\"pid\"},{\"aggregator\":\"max\",\"field\":\"finished_at\",\"field_script\":\"function invoke(fields,tags){if(fields.finished_at!=null\\u0026\\u0026fields.finished_at!=undefined) return fields.finished_at/1000000;return 0}\"},{\"aggregator\":\"max\",\"field\":\"started_at\",\"field_script\":\"function invoke(fields,tags){if(fields.started_at!=null\\u0026\\u0026fields.started_at!=undefined) return fields.started_at/1000000;return 0}\"},{\"aggregator\":\"value\",\"field\":\"finished_at\",\"field_script\":\"function invoke(fields,tags){if(fields.finished_at_max\\u003e0) return fields.finished_at_max;return '-'}\",\"trigger\":\"aggregated\"},{\"aggregator\":\"value\",\"field\":\"started_at\",\"field_script\":\"function invoke(fields,tags){if(fields.started_at_max\\u003e0) return fields.started_at_max;return '-'}\",\"trigger\":\"aggregated\"},{\"aggregator\":\"value\",\"field\":\"terminated_reason\",\"field_script\":\"function invoke(fields,tags){if(fields.oomkilled) return 'Out Of Memory';return 'Error Exit Code '+fields.exitcode_max;}\",\"trigger\":\"aggregated\"}],\"group\":[\"cluster_name\",\"pod_namespace\",\"pod_name\"],\"metrics\":[\"docker_container_summary\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"component_name\":\"#component_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("kubernetes_instance_mem","org","kubernetes","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","kubernetes组件实例内存状态","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"pod_namespace\",\"value\":\"kube-system\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"mem_usage_percent\",\"operator\":\"gt\",\"value\":70},{\"aggregator\":\"max\",\"alias\":\"mem_usage_value\",\"field\":\"mem_usage\"},{\"aggregator\":\"max\",\"alias\":\"mem_limit_value\",\"field\":\"mem_limit\"},{\"aggregator\":\"max\",\"alias\":\"mem_max_usage_value\",\"field\":\"mem_max_usage\"},{\"aggregator\":\"max\",\"alias\":\"mem_allocation_value\",\"field\":\"mem_allocation\"}],\"group\":[\"cluster_name\",\"container_id\"],\"metrics\":[\"docker_container_summary\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"component_name\":\"#pod_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":2}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("kubernetes_instance_ready","org","kubernetes","{\"alert_group\":\"{{cluster_name}}-{{daemonset_name}}-{{statefulset_name}}-{{deployment_name}}\",\"level\":\"FATAL\",\"recover\":\"true\",\"tickets_metric_key\":\"{{daemonset_name}}-{{statefulset_name}}-{{deployment_name}}\"}","kubernetes组件实例Ready状态异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"namespace\",\"value\":\"kube-system\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"not_ready_value\",\"field\":\"not_ready\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return fields.number_unavailable}else{if(tags.statefulset_name){return fields.replicas-fields.replicas_ready}else{if(tags.deployment_name){return fields.replicas_unavailable}}}return 0}\",\"operator\":\"gt\",\"value\":0},{\"aggregator\":\"max\",\"alias\":\"ready_value\",\"field\":\"ready_value\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return fields.number_available}else{if(tags.statefulset_name){return fields.replicas_ready}else{if(tags.deployment_name){return fields.replicas_available}}}return 0}\"},{\"aggregator\":\"max\",\"alias\":\"total_value\",\"field\":\"total_value\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return fields.number_unavailable+fields.number_available}else{if(tags.statefulset_name){return fields.replicas}else{if(tags.deployment_name){return fields.replicas}}}return 0}\"},{\"aggregator\":\"value\",\"alias\":\"resource_name_value\",\"field\":\"resource_name_value\",\"field_script\":\"function invoke(fields,tags){if(tags.daemonset_name){return tags.daemonset_name}else{if(tags.statefulset_name){return tags.statefulset_name}else{if(tags.deployment_name){return tags.deployment_name}}}return null};\"}],\"group\":[\"cluster_name\",\"namespace\",\"daemonset_name\",\"statefulset_name\",\"deployment_name\"],\"metrics\":[\"kubernetes_daemonset\",\"kubernetes_statefulset\",\"kubernetes_deployment\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"component_name\":\"#resource_name_value\",\"daemonset_name\":\"#daemonset_name\",\"deployment_name\":\"#deployment_name\",\"namespace\":\"#namespace\",\"org_name\":\"#org_name\",\"statefulset_name\":\"#statefulset_name\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("kubernetes_node","org","kubernetes","{\"alert_group\":\"{{cluster_name}}-{{node_name}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{node_name}}\"}","kubernetes节点异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"neq\",\"tag\":\"offline\",\"value\":\"true\"}],\"functions\":[{\"aggregator\":\"values\",\"field\":\"ready\",\"operator\":\"all\",\"value\":false},{\"aggregator\":\"max\",\"alias\":\"allocatable_pods_value\",\"field\":\"allocatable_pods\"},{\"aggregator\":\"max\",\"alias\":\"capacity_pods_value\",\"field\":\"capacity_pods\"},{\"aggregator\":\"max\",\"alias\":\"allocatable_cpu_cores_value\",\"field\":\"allocatable_cpu_cores\"},{\"aggregator\":\"max\",\"alias\":\"capacity_cpu_cores_value\",\"field\":\"capacity_cpu_cores\"},{\"aggregator\":\"max\",\"alias\":\"allocatable_memory_bytes_value\",\"field\":\"allocatable_memory_bytes\"},{\"aggregator\":\"max\",\"alias\":\"capacity_memory_bytes_value\",\"field\":\"capacity_memory_bytes\"}],\"group\":[\"cluster_name\",\"node_name\"],\"metrics\":[\"kubernetes_node\"],\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"component_name\":\"#node_name\",\"node_name\":\"#node_name\",\"org_name\":\"#org_name\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("machine_cluster_clock","org","machine","{\"alert_group\":\"{{cluster_name}}-{{host_ip}}\",\"display_url_id\":\"machine_cluster_clock\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{host_ip}}\"}","机器时钟一致性异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"elapsed_abs\",\"operator\":\"gte\",\"value\":5000},{\"aggregator\":\"avg\",\"alias\":\"send_timestamp\",\"field\":\"send_timestamp\"},{\"aggregator\":\"avg\",\"alias\":\"receive_timestamp\",\"field\":\"receive_timestamp\"}],\"group\":[\"cluster_name\",\"host_ip\"],\"metric\":\"cluster_clock\",\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"labels\":\"#labels\",\"org_name\":\"#org_name\",\"source_host_ip\":\"#source_host_ip\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("machine_cpu","org","machine","{\"alert_group\":\"{{cluster_name}}-{{host_ip}}\",\"display_url_id\":\"machine_cpu\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{host_ip}}\"}","机器CPU","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"cpu_usage_active\",\"operator\":\"gte\",\"value\":95}],\"group\":[\"cluster_name\",\"host_ip\"],\"metric\":\"host_summary\",\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"labels\":\"#labels\",\"org_name\":\"#org_name\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("machine_disk","org","machine","{\"alert_group\":\"{{cluster_name}}-{{host_ip}}-{{device}}\",\"display_url_id\":\"machine_disk\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{host_ip}}\"}","机器磁盘","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"neq\",\"tag\":\"type\",\"value\":\"netdata\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"used_percent_value\",\"field\":\"used_percent\",\"operator\":\"gte\",\"value\":86},{\"aggregator\":\"max\",\"alias\":\"total_value\",\"field\":\"total\"}],\"group\":[\"host_ip\",\"device\"],\"metric\":\"disk\",\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"device\":\"#device\",\"host_ip\":\"#host_ip\",\"labels\":\"#labels\",\"org_name\":\"#org_name\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("machine_disk_inode","org","machine","{\"alert_group\":\"{{cluster_name}}-{{host_ip}}-{{device}}\",\"display_url_id\":\"machine_disk\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{host_ip}}\"}","磁盘Inode异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"neq\",\"tag\":\"type\",\"value\":\"netdata\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"inode_used_percent_value\",\"field\":\"inode_used_percent\",\"field_script\":\"function invoke(field, tag){ return field.inodes_used/field.inodes_total*100 }\",\"operator\":\"gte\",\"value\":85},{\"aggregator\":\"max\",\"alias\":\"inodes_total_value\",\"field\":\"inodes_total\"}],\"group\":[\"host_ip\",\"device\"],\"metric\":\"disk\",\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"device\":\"#device\",\"host_ip\":\"#host_ip\",\"labels\":\"#labels\",\"org_name\":\"#org_name\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("machine_disk_util","org","machine","{\"alert_group\":\"{{cluster_name}}-{{host_ip}}\",\"display_url_id\":\"machine_disk_io\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{host_ip}}\"}","机器磁盘IO","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"path\",\"value\":null}],\"functions\":[{\"aggregator\":\"p75\",\"field\":\"pct_util\",\"operator\":\"gte\",\"value\":95}],\"group\":[\"host_ip\"],\"metric\":\"disk\",\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"labels\":\"#labels\",\"org_name\":\"#org_name\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("machine_load5","org","machine","{\"alert_group\":\"{{cluster_name}}-{{host_ip}}\",\"display_url_id\":\"machine_load\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{host_ip}}\"}","机器Load5","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"load5\",\"operator\":\"gte\",\"value\":20}],\"group\":[\"host_ip\"],\"metric\":\"host_summary\",\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"labels\":\"#labels\",\"org_name\":\"#org_name\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("machine_netdisk","org","machine","{\"alert_group\":\"{{cluster_name}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{cluster_name}}\"}","网盘","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"type\",\"value\":\"netdata\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"used_percent_value\",\"field\":\"used_percent\",\"operator\":\"gte\",\"value\":75},{\"aggregator\":\"max\",\"alias\":\"total_value\",\"field\":\"total\"}],\"group\":null,\"metric\":\"disk\",\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"labels\":\"#labels\",\"org_name\":\"#org_name\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("machine_netdisk_used","org","machine","{\"alert_group\":\"{{cluster_name}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{cluster_name}}\"}","网盘容量使用量异常告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"eq\",\"tag\":\"type\",\"value\":\"netdata\"}],\"functions\":[{\"aggregator\":\"max\",\"alias\":\"used\",\"field\":\"used\",\"field_script\":\"function invoke(field, tag){ return field.used/1024/1024/1024 }\",\"operator\":\"gte\",\"value\":300},{\"aggregator\":\"max\",\"alias\":\"total\",\"field_script\":\"function invoke(field, tag){ return field.total/1024/1024/1024 }\"}],\"group\":null,\"metric\":\"disk\",\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"labels\":\"#labels\",\"org_name\":\"#org_name\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("machine_status","org","machine","{\"alert_group\":\"{{cluster_name}}-{{host_ip}}\",\"display_url_id\":\"machine_crash\",\"level\":\"FATAL\",\"recover\":\"true\",\"tickets_metric_key\":\"{{host_ip}}\"}","机器宕机","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"values\",\"field\":\"status\",\"operator\":\"all\",\"value\":\"not_ready\"},{\"aggregator\":\"max\",\"alias\":\"last_timestamp_value\",\"field\":\"last_timestamp\"}],\"group\":[\"host_ip\"],\"metric\":\"machine_status\",\"outputs\":[\"alert\"],\"select\":{\"_meta\":\"#_meta\",\"_metric_scope\":\"#_metric_scope\",\"_metric_scope_id\":\"#_metric_scope_id\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"labels\":\"#labels\",\"org_name\":\"#org_name\"},\"window\":5}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("api_gateway_cpu","org","micro_service","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"false\",\"tickets_metric_key\":\"{{container_id}}\"}","API网关实例CPU使用率异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"in\",\"tag\":\"addon_type\",\"value\":[\"api-gateway\",\"postgresql\"]}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"cpu_usage_percent\",\"field_script\":\"function invoke(fields,tags){return fields.cpu_limit===0?fields.cpu_usage_percent:fields.cpu_usage_percent/fields.cpu_limit}\",\"operator\":\"gte\",\"value\":90},{\"aggregator\":\"max\",\"alias\":\"cpu_limit_value\",\"field\":\"cpu_limit\"},{\"aggregator\":\"max\",\"alias\":\"cpu_allocation_value\",\"field\":\"cpu_allocation\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("api_gateway_mem","org","micro_service","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","API网关实例内存使用率异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"in\",\"tag\":\"addon_type\",\"value\":[\"api-gateway\",\"postgresql\"]}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"mem_usage_percent\",\"operator\":\"gte\",\"value\":90},{\"aggregator\":\"max\",\"alias\":\"mem_usage_value\",\"field\":\"mem_usage\"},{\"aggregator\":\"max\",\"alias\":\"mem_limit_value\",\"field\":\"mem_limit\"},{\"aggregator\":\"max\",\"alias\":\"mem_max_usage_value\",\"field\":\"mem_max_usage\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("register_center_cpu","org","micro_service","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","注册中心实例CPU使用率异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"in\",\"tag\":\"addon_type\",\"value\":[\"nacos\",\"zkproxy\"]}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"cpu_usage_percent\",\"field_script\":\"function invoke(fields,tags){return fields.cpu_limit===0?fields.cpu_usage_percent:fields.cpu_usage_percent/fields.cpu_limit}\",\"operator\":\"gte\",\"value\":90},{\"aggregator\":\"max\",\"alias\":\"cpu_limit_value\",\"field\":\"cpu_limit\"},{\"aggregator\":\"max\",\"alias\":\"cpu_allocation_value\",\"field\":\"cpu_allocation\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("register_center_mem","org","micro_service","{\"alert_group\":\"{{cluster_name}}-{{container_id}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{container_id}}\"}","注册中心实例内存使用率异常","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"},{\"operator\":\"in\",\"tag\":\"addon_type\",\"value\":[\"nacos\",\"zkproxy\"]}],\"functions\":[{\"aggregator\":\"avg\",\"field\":\"mem_usage_percent\",\"operator\":\"gte\",\"value\":90},{\"aggregator\":\"max\",\"alias\":\"mem_usage_value\",\"field\":\"mem_usage\"},{\"aggregator\":\"max\",\"alias\":\"mem_limit_value\",\"field\":\"mem_limit\"},{\"aggregator\":\"max\",\"alias\":\"mem_max_usage_value\",\"field\":\"mem_max_usage\"}],\"group\":[\"container_id\"],\"metric\":\"docker_container_summary\",\"outputs\":[\"alert\"],\"select\":{\"addon_id\":\"#addon_id\",\"addon_type\":\"#addon_type\",\"cluster_name\":\"#cluster_name\",\"container_id\":\"#container_id\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"pod_ip\":\"#pod_ip\",\"pod_name\":\"#pod_name\",\"pod_namespace\":\"#pod_namespace\"},\"window\":1}");
INSERT `sp_alert_rules`(`alert_index`,`alert_scope`,`alert_type`,`attributes`,`name`,`template`) VALUES("sidecar_circuit_breaker","micro_service","micro_service","{\"alert_group\":\"{{terminus_key}}\",\"level\":\"WARNING\",\"recover\":\"true\",\"tickets_metric_key\":\"{{terminus_key}}\"}","服务熔断通知告警","{\"filters\":[{\"operator\":\"eq\",\"tag\":\"terminus_key\",\"value\":\"$terminus_key\"},{\"operator\":\"eq\",\"tag\":\"org_name\",\"value\":\"$org_name\"}],\"functions\":[{\"aggregator\":\"sum\",\"field\":\"count\",\"operator\":\"gte\",\"value\":1}],\"group\":[\"service_name\"],\"metric\":\"sidecar_circuit_breaker\",\"outputs\":[\"alert\"],\"select\":{\"application_id\":\"#application_id\",\"application_name\":\"#application_name\",\"cluster_name\":\"#cluster_name\",\"host_ip\":\"#host_ip\",\"org_name\":\"#org_name\",\"project_name\":\"#project_name\",\"runtime_name\":\"#runtime_name\",\"service_name\":\"#service_name\",\"terminus_key\":\"#terminus_key\",\"workspace\":\"#workspace\"},\"window\":1}");
